Subject: bug#7337: 23.2; (require 'time) changes timezone

From: Kevin Ryde <[email-masked]>
Date: Sat, 06 Nov 2010 08:46:42 +1100

Doing a (require 'time) changes the `current-time-zone' to the system
default per a (set-time-zone-rule nil).  I think that loading a .el
shouldn't change the zone.  The effect can be seen from "emacs -Q"

    (let (before after)
      (set-time-zone-rule "ABC+1")
      (setq before (current-time-zone))
      (require 'time)
      (setq after  (current-time-zone))
      (list (car before) (car after)))
    => (-3600 39600)

where I expected

    => (-3600 -3600)

which is what happens if evaluated a second time, since (require 'time)
is then a no-op.

I suppose it comes from display-time-world-list probing whether the
Olson timezone names are known to the C library.  I think it should save
and restore the existing TZ the way `add-change-log-entry' and
`time-stamp-string' do.

For some of my own code lately I tried a macro to hide the details and
the unwind-protect a bit.  Perhaps a name like with-time-zone-rule or
with-temporary-time-zone-rule would match set-time-zone-rule better than
"...-TZ".

(defmacro xtide-with-TZ (tz &rest body)
  "Run BODY with `set-time-zone-rule' temporarily to TZ.
The current timezone (per `getenv' \"TZ\") is restored by an
`unwind-protect'."
  (declare (indent 1))
  `(let ((xtide-with-TZ--old (getenv "TZ")))
     (set-time-zone-rule ,tz)
     (unwind-protect
         (progn ,@body)
       (set-time-zone-rule xtide-with-TZ--old))))

In GNU Emacs 23.2.1 (i486-pc-linux-gnu, GTK+ Version 2.20.0)
 of 2010-05-16 on raven, modified by Debian
configured using `configure  '--build' 'i486-linux-gnu' '--build' 'i486-linux-gnu' '--prefix=/usr' '--sharedstatedir=/var/lib' '--libexecdir=/usr/lib' '--localstatedir=/var/lib' '--infodir=/usr/share/info' '--mandir=/usr/share/man' '--with-pop=yes' '--enable-locallisppath=/etc/emacs23:/etc/emacs:/usr/local/share/emacs/23.2/site-lisp:/usr/local/share/emacs/site-lisp:/usr/share/emacs/23.2/site-lisp:/usr/share/emacs/site-lisp:/usr/share/emacs/23.2/leim' '--with-x=yes' '--with-x-toolkit=gtk' '--with-toolkit-scroll-bars' 'build_alias=i486-linux-gnu' 'CFLAGS=-DDEBIAN -g -O2' 'LDFLAGS=-g' 'CPPFLAGS=''

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: nil
  value of $LC_CTYPE: nil
  value of $LC_MESSAGES: nil
  value of $LC_MONETARY: nil
  value of $LC_NUMERIC: nil
  value of $LC_TIME: nil
  value of $LANG: en_AU
  value of $XMODIFIERS: nil
  locale-coding-system: iso-latin-1-unix
  default enable-multibyte-characters: t